/** DLLC^[tF[X
 */
/*
 * Copyright (c) 2000-2005 shimitei
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */
//---------------------------------------------------------------------------
#include <vcl.h>
#include <Registry.hpp>
#include <Masks.hpp>
#pragma hdrstop

#include "ifmm.h"
#include "ifmmedia.h"
#include "OptionUnit.h"
//---------------------------------------------------------------------------
USEFORM("PlayerUnit.cpp", PlayForm);
USEFORM("OptionUnit.cpp", DialogForm);
//---------------------------------------------------------------------------
void  __fastcall loadOptions(void) ;
bool __fastcall putTempFile(char *tempfname, const char *buf, const long len) ;
bool __fastcall getFileIcon(const char *filename, HANDLE *pHBInfo, HANDLE *pHBm, const DWORD filetype) ;
int __fastcall GetPictureEx(const LPSTR buf, const long len, const unsigned int flag,
                   HANDLE *pHBInfo, HANDLE *pHBm,
                   const SPI_PROGRESS lpPrgressCallback,
                   const long lData, const bool IsPreview) ;
//---------------------------------------------------------------------------

/* O[o */
TPluginVar g_var ;
const char *g_ifmmCopyrightString = "MediaPlayer v1.3.4" ;
const char *g_titleString = "ifmm.spi" ;
//---------------------------------------------------------------------------
/** ȂR[obN
 * R[obN֐NULL̏ꍇɂgpB
 * xNULL`FbNȂĂǂ悤ɂ邽߁B
 */
static int __stdcall nopCallback(int nNum, int nDenom, long lData)
{
    return 0 ;
}
//---------------------------------------------------------------------------
/** DLLGg[|Cg
 */
int WINAPI DllEntryPoint(HINSTANCE hinst, unsigned long reason, void*)
{
    switch ( reason )
    {
        case DLL_PROCESS_ATTACH :
            loadOptions() ;
            break ;
    }

    return 1 ;
}
//---------------------------------------------------------------------------
/** ݒ
 */
void __fastcall loadDefault(IFMMVAR_STRUCT &var)
{
    // ɓinjĐ
    var.option[ OPTION_MemoryPlay ] = TRUE ;
    // 킴ƃG[Ԃ
    var.option[ OPTION_ReturnErr ]  = FALSE ;
    // EBhEɑO
    var.option[ OPTION_StayOnTop ]  = FALSE ;
    // v[[ANeBu
    var.option[ OPTION_NoActive ]   = FALSE ;
    // v[[ʒuŒ
    var.option[ OPTION_WindowPos ]  = FALSE ;
    var.option[ OPTION_WindowPosX ] = 0 ;
    var.option[ OPTION_WindowPosY ] = 0 ;
    // v[[ŏŋN
    var.option[ OPTION_Minimized ]  = FALSE ;
    // Susieɓ̍ŏ̃t[Ԃ
    var.option[ OPTION_PreviewMovie ] = TRUE ;
    // ̃vr[ʒu(b)
    var.option[ OPTION_PreviewPos1 ] = 0 ;
    var.option[ OPTION_PreviewPos2 ] = 5 ;
    // ʒɕ\
    var.option[ OPTION_MovieCenter ] = FALSE ;
    // ̃TCY{
    var.option[ OPTION_MovieSize ] = MOVIESIZE_X1 ;
    // debugƂ...
    var.option[ OPTION_DebugMode ] = FALSE ;
    // Susie݊ȊOgps
    var.option[ OPTION_SusieOnly ] = TRUE ;

    // JX^TCY
    var.option[ OPTION_MovieHeight ] = Screen->WorkAreaHeight * 2 / 3 ;
    var.option[ OPTION_MovieWidth ]  = Screen->WorkAreaWidth  * 2 / 3 ;
    var.option[ OPTION_MoviePosY ] = ( (Screen->WorkAreaHeight - var.option[ OPTION_MovieHeight ] -78/*PlayForm->Height*/) /2 ) ;
    var.option[ OPTION_MoviePosX ] = ( (Screen->WorkAreaWidth  - var.option[ OPTION_MovieWidth ]  -(284 -276)/*PlayForm->Width  -PlayForm->ClientWidth*/)  /2 ) ;

    //uSusie݊vH
    /*
      Susie ̂悤ɃJ^OiTlCj쐬Ƃ GetPreviewA
      ʂɕ\Ƃ GetPicture ĂяoB
      ܂ ifmm.spi ɓ삷邱ƂmFĂ\tgB
      vOCĂяoexe̖OŃ`FbN
      "susie"܂"ccnn"܂܂ĂΗǂ
      ̃\tg̓WXgɓo^
    */
    AnsiString exename = ::ExtractFileName( ParamStr(0) ).LowerCase() ;
    if (   exename.AnsiPos( "susie" )
        || exename.AnsiPos( "ccnn" )
       )
    {
        var.option[ OPTION_IsSusie ] = TRUE ;
    }
    else
    {
        var.option[ OPTION_IsSusie ] = FALSE ;
        // WXgSusie݊`FbN
        TStringList* sl = new TStringList() ;
        getSusieCompatiAppName( sl ) ;
        int count = sl->Count ;
        for (int i=0; i < count; i++)
        {
            if ( exename.AnsiPos( sl->Strings[i].LowerCase() ) != 0 )
            {
                var.option[ OPTION_IsSusie ] = TRUE ;
                break ;
            }
        }
        delete sl ;
    }
    // ViXōĐ
    var.option[ OPTION_PlayByViX ] = TRUE ;
    //ĂяoViXH
    if ( exename.AnsiPos( "vix" ) != 0 )
    {
        var.option[ OPTION_IsViX ] = TRUE ;
    }
    else
    {
        var.option[ OPTION_IsViX ] = FALSE ;
    }

    // T|[g`
    for (int i=0; i < FILETYPE_COUNT; i++)
    {
        var.playable[i] = true;
    }
    // ̂̓ftHg̓It
    var.playable[ MOVPLAY ] = false ;
    var.playable[ OGGPLAY ] = false ;
    var.playable[ RMPLAY ] = false ;
}
//---------------------------------------------------------------------------
/** ݒWXgǂ݂
 */
void __fastcall loadOptions(void)
{
    AnsiString userDefExt = "*.wma;*.wmv;*.asf;" ;
    IFMMVAR_STRUCT var ;
    loadDefault( var ) ;

    TRegistry *reg = new TRegistry( KEY_EXECUTE ) ;
    //reg->RootKey = HKEY_CURRENT_USER ;
    bool opened = reg->OpenKey( "\\Software\\shimitei\\ifmm", false ) ;
if ( opened )
{

  try
  {
#define GETSET_REGISTRY(type, index, opt) \
    if ( reg->ValueExists( opt ) ) \
    { \
        var.option[ index ] = reg->Read ## type( opt ) ; \
    }

    GETSET_REGISTRY( Bool, OPTION_MemoryPlay, "Memory" ) ;
    GETSET_REGISTRY( Bool, OPTION_ReturnErr, "Error" ) ;
    GETSET_REGISTRY( Bool, OPTION_StayOnTop, "StayOnTop" ) ;
    GETSET_REGISTRY( Bool, OPTION_NoActive, "NoActive" ) ;

    GETSET_REGISTRY( Bool, OPTION_WindowPos, "WindowPos" ) ;
    GETSET_REGISTRY( Integer, OPTION_WindowPosX, "WindowPosX" ) ;
    GETSET_REGISTRY( Integer, OPTION_WindowPosY, "WindowPosY" ) ;

    GETSET_REGISTRY( Bool, OPTION_PreviewMovie, "PreviewMovieFrame" ) ;

    GETSET_REGISTRY( Integer, OPTION_PreviewPos1, "PreviewPos1" ) ;
    GETSET_REGISTRY( Integer, OPTION_PreviewPos2, "PreviewPos2" ) ;

    GETSET_REGISTRY( Bool, OPTION_Minimized, "Minimized" ) ;
    GETSET_REGISTRY( Integer, OPTION_MovieSize, "MovieSize" ) ;
    GETSET_REGISTRY( Bool, OPTION_MovieCenter, "MovieCenter" ) ;

    // JX^TCY
    int tmpX = 0 ;
    int tmpY = 0 ;
    int tmpH = 0 ;
    int tmpW = 0 ;
#define GET_REGISTRY(type, var, opt) \
    if ( reg->ValueExists( opt ) ) \
    { \
        var = reg->Read ## type( opt ) ; \
    }
    GET_REGISTRY( Integer, tmpX, "MoviePosX" ) ;
    GET_REGISTRY( Integer, tmpY, "MoviePosY" ) ;
    GET_REGISTRY( Integer, tmpH, "MovieHeight" ) ;
    GET_REGISTRY( Integer, tmpW, "MovieWidth" ) ;
    if ( (tmpH != 0) && (tmpW != 0) )
    {
        var.option[ OPTION_MoviePosX   ] = tmpX ;
        var.option[ OPTION_MoviePosY   ] = tmpY ;
        var.option[ OPTION_MovieHeight ] = tmpH ;
        var.option[ OPTION_MovieWidth  ] = tmpW ;
    }

    GETSET_REGISTRY( Bool, OPTION_SusieOnly, "SusieOnly" ) ;
    GETSET_REGISTRY( Bool, OPTION_PlayByViX, "PlayByViX" ) ;
    GETSET_REGISTRY( Bool, OPTION_DebugMode, "Debug" ) ;

    // T|[g`
#define GETSET_PLAYABLE(opt) \
    if ( reg->ValueExists( #opt ) ) \
    { \
        var.playable[ opt##PLAY ] = reg->ReadBool( #opt ) ; \
    }
    GETSET_PLAYABLE( WAVE ) ;
    GETSET_PLAYABLE( MIDI ) ;
    GETSET_PLAYABLE( AVI ) ;
    GETSET_PLAYABLE( AIFF ) ;
    GETSET_PLAYABLE( MOV ) ;
    GETSET_PLAYABLE( MPEG ) ;
    GETSET_PLAYABLE( MPA ) ;
    GETSET_PLAYABLE( AU ) ;
    GETSET_PLAYABLE( OGG ) ;
    GETSET_PLAYABLE( RM ) ;
    GETSET_PLAYABLE( USER ) ;

    if ( reg->ValueExists( "UserDefExt" ) )
    {
        userDefExt = reg->ReadString( "UserDefExt" ) ;
    }
    else
    {
        userDefExt = "*.wma;*.wmv;*.asf;" ;
    }

    reg->CloseKey() ;
  }
  catch (...)
  {
    //throw ;
  }
}
    delete reg ;

    g_var.set( &var, userDefExt ) ;
}
//---------------------------------------------------------------------------
/** Susie݊o^Avǂ
 * ֐...
 */
void __fastcall getSusieCompatiAppName(TStringList* AppList)
{
    //AppList->Clear() ;
    TRegistry *reg = new TRegistry(KEY_EXECUTE);
    //reg->RootKey = HKEY_CURRENT_USER ;
    bool opened = reg->OpenKey( "\\Software\\shimitei\\ifmm\\SusieCompati", false ) ;
    if ( opened )
    {
        reg->GetValueNames( AppList ) ;
    }

    delete reg ;
}
//---------------------------------------------------------------------------
/** ꎞt@C쐬
 * @param tempfname 쐬e|t@CԂ
 * @param buf f[^ւ̃|C^
 * @param len f[^TCY
 * @return 쐬ɐtrueAsfalseԂ
 */
bool __fastcall putTempFile(char *tempfname, const char *buf, const long len)
{
    char dir[ MAX_PATH ] ;

    if ( ::GetTempPath( MAX_PATH, dir ) == 0 )
    {
        //::MessageBox( NULL, "e|tH_̎擾ɎsB", "ifmm.spi", MB_OK ) ;
        return false ;
    }
    if ( ::GetTempFileName( dir, "ifm", 0, tempfname ) == 0 )
    {
        //::MessageBox( NULL, "e|t@C̍쐬ɎsB", "ifmm.spi", MB_OK ) ;
        return false ;
    }

    HANDLE hf = ::CreateFile( tempfname, GENERIC_WRITE, FILE_SHARE_READ, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL ) ;
    if ( hf == INVALID_HANDLE_VALUE )
    {
        //::MessageBox( NULL, "e|t@C̍쐬ɎsB", "ifmm.spi", MB_OK ) ;
        return false ;
    }
    DWORD ReadBytes ;
    if ( ! ::WriteFile( hf, buf, len, &ReadBytes, NULL ) )
    {
        //::MessageBox( NULL, "e|t@C݂̏ɎsB", "ifmm.spi", MB_OK ) ;
        ::CloseHandle( hf ) ;
        ::DeleteFile( tempfname ) ;
        return false ;
    }
    ::CloseHandle( hf ) ;

    return true ;
}
//---------------------------------------------------------------------------
/** t@C^CṽACRnh𓾂
 * @param filename t@CBNULL
 * @param filetype t@C^Cv
 * @return ACRnhԂ
 */
HICON __fastcall getIconHandle(const char *filename, const DWORD filetype, DWORD flag)
{
    /* t@C^CvƓ悤ȕ */
    char *extTable[] =
    {
        "*.wav", /* 0 */
        "*.wav", /* 1 */
        "*.aif",
        "*.mid",
        "*.avi",
        "*.mov", /* 5 */
        "*.mpg",
        "*.mpa",
        "*.au",
        "*.ogg",
        "*.rm",  /* 10 */
    } ;
    SHFILEINFO fi ;
    DWORD index = (filetype & 0xff) ;

    if ( index >= (sizeof(extTable)/sizeof(extTable[0])) ) index = 0 ;
    AnsiString ext = extTable[ index ];

    if ( filetype == FILETYPE_USER )
    {
        if ( filename == NULL )
        {
            ext = "*.spi" ;
        }
        else
        {
            ext = "*" ;
            ext += ::ExtractFileExt(filename) ;
        }
    }

    ::SHGetFileInfo( ext.c_str(), NULL, &fi, sizeof(SHFILEINFO),
                SHGFI_USEFILEATTRIBUTES | SHGFI_ICON | flag ) ;
    return fi.hIcon ;
}
//---------------------------------------------------------------------------
/** ACRnhDIB쐬
 * @param filename t@CBNULL
 * @param pHBInfo SusieɕԂBITMAPINFO߂nh̃|C^
 * @param pHBm SusieɕԂBITMAPf[^߂nh̃|C^
 * @param filetype
 * @return 
 */
bool __fastcall getFileIcon(const char *filename, HANDLE *pHBInfo, HANDLE *pHBm, const DWORD filetype)
{
//TODO:܂肭ǂ
    Graphics::TBitmap *bmp = new (Graphics::TBitmap) ;
    bmp->Height = 32 ; //32x32Ɍߕt
    bmp->Width  = 32 ;
    bmp->PixelFormat = pf24bit ;

    HICON hIcon = getIconHandle( filename, filetype, SHGFI_LARGEICON ) ;
    bool result = ::DrawIconEx( bmp->Canvas->Handle, 0, 0, hIcon, 0, 0, 0, NULL, DI_NORMAL ) ;

    if ( result )
    {
        TMemoryStream *ms = new TMemoryStream() ;
        bmp->SaveToStream(ms);
        char *buffer = (char *)ms->Memory ;

        BITMAPFILEHEADER *pbm_fh ;
        BITMAPINFOHEADER *pbm_info ;
        pbm_fh = (BITMAPFILEHEADER *)buffer ;
        pbm_info = (BITMAPINFOHEADER *)( buffer + sizeof(BITMAPFILEHEADER) ) ;
        int img_size = pbm_info->biWidth * 3;
        img_size = (img_size +3) & ~3 ; // 4byteEɍ킹
        img_size *= abs( pbm_info->biHeight ) ;
        *pHBInfo = ::LocalAlloc( LMEM_FIXED, sizeof(BITMAPINFOHEADER) ) ;
        if ( *pHBInfo == NULL )
        {
            result = false ;
        }
        else
        {
            *pHBm = ::LocalAlloc( LMEM_FIXED, img_size ) ;
            if ( *pHBm == NULL )
            {
                ::LocalFree( *pHBInfo ) ;
                result = false ;
            }
            else
            {
                BITMAPINFOHEADER *pInfo ;
                pInfo = (BITMAPINFOHEADER *)*pHBInfo ;
                pInfo->biSize          = sizeof(BITMAPINFOHEADER) ;
                pInfo->biWidth         = pbm_info->biWidth ;
                pInfo->biHeight        = pbm_info->biHeight ;
                pInfo->biPlanes        = 1 ;
                pInfo->biBitCount      = 24 ;
                pInfo->biCompression   = 0 ;
                pInfo->biSizeImage     = img_size ;
                pInfo->biXPelsPerMeter = 0 ;
                pInfo->biYPelsPerMeter = 0 ;
                pInfo->biClrUsed       = 0 ;
                pInfo->biClrImportant  = 0 ;

                char *Bm = (char *)*pHBm;
                char *p = buffer + pbm_fh->bfOffBits ;
                ::CopyMemory( Bm, p, img_size ) ;
            }
        }
        delete ms ;
    }

    ::DestroyIcon( hIcon ) ;
    delete bmp ;

    return result ;
}
//---------------------------------------------------------------------------
/** gq̃}b`eXg
 * @param filename t@C
 * @param ext̓J}؂ "*.html;*.htm;*.eml"
 *        ext ̓e *j* .
 * @return }b`trueԂ
 */
bool __fastcall matchesExt(const AnsiString &filename, char *ext)
{
    char *msk = ext;
    for (;;) {
        if (*msk == '\0') return false;
        char *p = AnsiStrScan(msk, ';');
        if (p) {
            *p = '\0';
        }
        if (MatchesMask(filename, msk)) return true;
        if (p == NULL) {
            return false;
        }
        msk = p+1;
    }
}
//---------------------------------------------------------------------------

//ȉSusievOCAPI
//---------------------------------------------------------------------------
int __stdcall GetPluginInfo(int infono, LPSTR buf, int buflen)
{
    char *infomation[] = {
    /* 0     */  "00IN",
    /* 1     */  (char*)g_ifmmCopyrightString,
    /* 2*0+2 */  NULL, /* filemask */
    /* 2*0+3 */  "Media file",
    } ;

    // ͈͊O
    if ( infono < 0 ) return 0 ;
    if ( infono >= (sizeof(infomation) / sizeof(infomation[0])) ) return 0 ;

    if ( infono == 2 )
    {
        // Ήt@C̊gq
        AnsiString filemask = "" ;
        bool playable[ FILETYPE_COUNT ] ;
        g_var.getPlayableTable( playable ) ;
        if (playable[WAVEPLAY]) filemask += "*.wav;" ;
        if (playable[MIDIPLAY]) filemask += "*.mid;*.midi;" ;
        if (playable[AVIPLAY] ) filemask += "*.avi;" ;
        if (playable[AIFFPLAY]) filemask += "*.aif;*,aiff;" ;
        if (playable[MOVPLAY] ) filemask += "*.mov;" ;
        if (playable[MPEGPLAY]) filemask += "*.mpg;*.mpeg;*.mpe;*.m1v;*.m2v;*.mpv2;*.mp2v;" ;
        if (playable[MPAPLAY] ) filemask += "*.mp3;*.mpa;*.mp2;*.m1a;*.m2a;" ;
        if (playable[AUPLAY]  ) filemask += "*.au;*.snd;" ;
        if (playable[OGGPLAY] ) filemask += "*.ogg;" ;
        if (playable[RMPLAY]  ) filemask += "*.rm;*.ra;" ;
        if (playable[USERPLAY] ) filemask += g_var.getUserDefExt() ;

        if ( filemask.IsEmpty() )
        {
            ::lstrcpyn( buf, "", buflen ) ;
        }
        else
        {
            ::lstrcpyn( buf, filemask.c_str(), buflen ) ;
        }
    }
    else
    {
        // K'\0'H
        ::lstrcpyn( buf, infomation[ infono ], buflen ) ;
    }

    // '\0'͐Ȃ
    return ::lstrlen( buf ) ;
}
//---------------------------------------------------------------------------
int __stdcall IsSupported(LPSTR filename, DWORD dw)
{
    char headerBuff[ HEAD_BUFF ] ;
    char *data ;

    if ( (dw & 0xFFFF0000) == 0 )
    {
        /* t@Cnh */
        DWORD ReadBytes ;
        ::ZeroMemory( headerBuff, HEAD_BUFF ) ;
        if ( ! ::ReadFile( (HANDLE)dw, headerBuff, HEAD_BUFF, &ReadBytes, NULL) )
        {
            return 0 ;
        }
        data = headerBuff ;
    }
    else
    {
        /*  */
        data = (char *)dw ;
    }

    /* Ήt@CmF */
    if ( getFileType(data, filename) != FILETYPE_UNKNOWN )
    {
        return 1 ;
    }

    return 0 ;
}
//---------------------------------------------------------------------------
int __stdcall GetPictureInfo
(LPSTR buf, long len, unsigned int flag, struct PictureInfo *lpInfo)
{
/* ŒԂĂ */

    char headerBuff[ HEAD_BUFF ] ;
    char *data ;
    char *filename ;

    switch ( flag & 7 )
    {
        case 0: /* t@C */
        {
            HANDLE hf ;
            DWORD ReadBytes ;
            hf = ::CreateFile( buf, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL ) ;
            if ( hf == INVALID_HANDLE_VALUE )
            {
                return SPI_FILE_READ_ERROR ;
            }
            /* }bNoCiɂ͑ΉłȂ̂ŃV[NȂ
             */
            //::SetFilePointer( hf, len, NULL, FILE_BEGIN ) ;
            if ( ! ::ReadFile( hf, headerBuff, HEAD_BUFF, &ReadBytes, NULL ) )
            {
                ::CloseHandle( hf ) ;
                return SPI_FILE_READ_ERROR ;
            }
            ::CloseHandle( hf ) ;
            data = headerBuff ;
            filename = buf ;
            break ;
        }
        case 1: /*  */
            data = buf ;
            filename = NULL ;
            break ;
        default:
            return SPI_NO_FUNCTION ;
    }

    /* Ήt@CmF */
    if ( getFileType( data, filename ) == FILETYPE_UNKNOWN )
    {
        return SPI_NOT_SUPPORT ;
    }

    lpInfo->left       = 0 ;
    lpInfo->top        = 0 ;
    lpInfo->width      = 32 ;
    lpInfo->height     = 32 ;
    lpInfo->x_density  = 0 ;
    lpInfo->y_density  = 0 ;
    lpInfo->colorDepth = 24 ;
    lpInfo->hInfo      = NULL ;

    return SPI_ALL_RIGHT ;
}
//---------------------------------------------------------------------------
/** GetPreviewGetPicturȅ܂Ƃ߂
 */
int __fastcall GetPictureEx(
        const LPSTR buf, const long len, const unsigned int flag,
        HANDLE *pHBInfo, HANDLE *pHBm,
        const SPI_PROGRESS lpPrgressCallback,
        const long lData, const bool IsPreview)
{
    char headerBuff[ HEAD_BUFF ] ;
    char *data ;
    char *filename ;
    bool inmem ;

    switch ( flag & 7 )
    {
        case 0: /* t@C */
        {
            HANDLE hf ;
            DWORD ReadBytes ;
            hf = ::CreateFile( buf, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL ) ;
            if ( hf == INVALID_HANDLE_VALUE )
            {
                return SPI_FILE_READ_ERROR ;
            }
            /* }bNoCiɂ͑ΉłȂ̂ŃV[NȂ
             */
            //::SetFilePointer( hf, len, NULL, FILE_BEGIN) ;
            if ( ! ::ReadFile( hf, headerBuff, HEAD_BUFF, &ReadBytes, NULL ) )
            {
                ::CloseHandle( hf ) ;
                return SPI_FILE_READ_ERROR ;
            }
            ::CloseHandle( hf ) ;
            inmem = false ;
            filename = buf ;
            data = headerBuff ;
            break ;
        }
        case 1: /*  */
            //ɓinjĐH
            if ( ! g_var.getOption( OPTION_MemoryPlay ) )
            {
                return SPI_NOT_SUPPORT ;
            }
            data = buf ;
            inmem = true ;
            filename = NULL ;
            break ;
        default:
            return SPI_NO_FUNCTION ;
    }

    /* Ήt@CmF */
    DWORD filetype = getFileType( data, filename ) ;
    if ( filetype == FILETYPE_UNKNOWN ) return SPI_NOT_SUPPORT ;

    char tempfname[ MAX_PATH ] = "" ;
    // vr[łȂ΍Đ
    if ( ! IsPreview )
    {
        if ( inmem )
        {
            if ( ! putTempFile( tempfname, buf, len ) )
            {
                return SPI_FILE_READ_ERROR ;
            }
        }
        else
        {
            ::lstrcat( tempfname, buf ) ;
        }
        int ret = playMedia( tempfname, inmem, filetype, lpPrgressCallback, lData ) ;
        if ( inmem ) ::DeleteFile( tempfname ) ;
        if ( ret != SPI_ALL_RIGHT ) return ret ;
        // Susie摜\Ȃ悤ɂ킴ƁuG[vԂ
        if ( g_var.getOption( OPTION_ReturnErr ) )
        {
            return SPI_OTHER_ERROR ;
        }
    }

    if (   ! g_var.getOption( OPTION_PreviewMovie )
        || ! IsPreview
        || ! IS_MOVIE( filetype )
       )
    {
        if ( ! getFileIcon( filename, pHBInfo, pHBm, filetype ) )
        {
            return SPI_OTHER_ERROR ;
        }
    }
    else
    {
        bool result ;
        if ( inmem )
        {
            if ( ! putTempFile( tempfname, buf, len ) )
            {
                return SPI_FILE_READ_ERROR ;
            }
            result = getMovieFrame( tempfname, pHBInfo, pHBm ) ;
            DeleteFile( tempfname ) ;
        }
        else
        {
            ::lstrcpy( tempfname, buf ) ;
            result = getMovieFrame( tempfname, pHBInfo, pHBm ) ;
        }
        if ( ! result )
        {
            if ( ! getFileIcon( filename, pHBInfo, pHBm, filetype ) )
            {
                return SPI_OTHER_ERROR ;
            }
        }
    }

    return SPI_ALL_RIGHT ;
}
//---------------------------------------------------------------------------
int __stdcall GetPicture(
        LPSTR buf, long len, unsigned int flag,
        HANDLE *pHBInfo, HANDLE *pHBm,
        SPI_PROGRESS lpPrgressCallback, long lData)
{
    if (    g_var.getOption( OPTION_IsViX )
         && g_var.getOption( OPTION_PlayByViX )
       )
    {
        // ViXōĐ邽߂ɂ킴ƃG[Ԃ
        return SPI_OTHER_ERROR ;
    }

    if ( lpPrgressCallback == NULL ) lpPrgressCallback = nopCallback ;

    if (   ! g_var.getOption( OPTION_IsSusie )
        && g_var.getOption( OPTION_SusieOnly )
       )
    {
        // Susie݊ȊO
        return GetPreview( buf, len, flag, pHBInfo, pHBm, lpPrgressCallback, lData ) ;
    }

    // Susie݊
    return GetPictureEx( buf, len, flag, pHBInfo, pHBm, lpPrgressCallback, lData, false ) ;
}
//---------------------------------------------------------------------------
int __stdcall GetPreview(
    LPSTR buf, long len, unsigned int flag,
    HANDLE *pHBInfo, HANDLE *pHBm,
    SPI_PROGRESS lpPrgressCallback, long lData)
{
    if ( lpPrgressCallback == NULL ) lpPrgressCallback = nopCallback ;

    if ( lpPrgressCallback(0, 1, lData) ) return SPI_ABORT ;

    int errCode = GetPictureEx( buf, len, flag, pHBInfo, pHBm, lpPrgressCallback, lData, true ) ;

    if ( lpPrgressCallback(1, 1, lData) ) return SPI_ABORT ;

    return errCode ;
}
//---------------------------------------------------------------------------
int __stdcall ConfigurationDlg(HWND parent, int fnc)
{
//#define SPI_CFGDLG_ABOUT    0
#define SPI_CFGDLG_SETTING  1
//#define SPI_CFGDLG_RESERVED 2

    TDialogForm *form ;

#ifdef SPI_CFGDLG_ABOUT
    if ( fnc == SPI_CFGDLG_SETTING )
    {
        ::MessageBox( parent, g_ifmmCopyrightString, g_titleString, MB_ICONINFORMATION | MB_OK ) ;
        return SPI_ALL_RIGHT ;
    }
    else
#endif
    if ( fnc == SPI_CFGDLG_SETTING )
    {
#ifdef SetDlgH
        form = new TDialogForm( parent ) ;
#else
        form = new TDialogForm( NULL ) ;
#endif
        form->FormInit() ;
        form->ShowModal() ;
        delete form ;
        return SPI_ALL_RIGHT ;
    }

    return SPI_NO_FUNCTION ;
}
//---------------------------------------------------------------------------



